//
//  MyView.m
//  041_NSBitmapImageRep
//
//  Created by julius on 13/12/2008.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//
//#include "mt19937.h"

#import "MyView.h"

# include <stdio.h>
# include <stdlib.h>

# include "mt19937.h"
# include <time.h>



@implementation MyView

- (id)initWithFrame:(NSRect)pFrameRect {	
    if (! (self = [super initWithFrame:pFrameRect])) {
        NSLog(@"MyView initWithFrame *Error*");
		return self;
    } // end if
	
	nsRectFrameRect	= pFrameRect;
	
	unsigned int iseed = (unsigned int)time(NULL);
	sgenrand(iseed); /* any nonzero integer can be used as a seed */
	parametro = 0.5;
	init_option = 0;
	generation_time = 0;
	init_option = 0;
	
	NSInteger x; NSInteger y;
	// perform percoltion on the lattice 
	for (y = 0; y < (int)Y_SIZE; y++)for (x = 0; x < (int)X_SIZE; x++) 
	LatticeConfiguration[x][y] = 0;
		//if (genrand() < parametro) {LatticeConfiguration[x][y] = 1;}else{LatticeConfiguration[x][y] = 0;};	
	
	LatticeConfiguration[128][128] = 1;
	
	LatticeConfiguration[127][128] = 1;
	LatticeConfiguration[129][128] = 1;

	LatticeConfiguration[128][127] = 1;
	LatticeConfiguration[128][129] = 1;
	
	
	
	return self;
}

- (void)awakeFromNib {
	
	nsBitmapImageRepObj = [[NSBitmapImageRep alloc]
							initWithBitmapDataPlanes:NULL
							pixelsWide:nsRectFrameRect.size.width 
							pixelsHigh:nsRectFrameRect.size.height
							bitsPerSample:8 
							samplesPerPixel:3 
							hasAlpha:NO 
							isPlanar:NO 
							colorSpaceName:@"NSCalibratedRGBColorSpace" 
							bytesPerRow:0 
							bitsPerPixel:0];
	
	cgFloatRed			= 1.0;
	cgFloatRedUpdate	= 0.02;
} // end awakeFromNib

- (IBAction) startAnimation:(id)pId {
	if (nsTimerRef_1 ) {
		[nsTimerRef_1 invalidate];
		nsTimerRef_1	= nil; 
	}
	
	if (nsTimerRef_2 ) {
		[nsTimerRef_2 invalidate];
		nsTimerRef_2	= nil; 
	}
	
	nsTimerRef_1	= [NSTimer	scheduledTimerWithTimeInterval:0.05 
												  target:self 
												selector:@selector(updateLatticeConfiguration) 
												userInfo:NULL 
												 repeats:YES];
	
	
	nsTimerRef_2	= [NSTimer	scheduledTimerWithTimeInterval:0.01 
												  target:self 
												selector:@selector(paintGradientBitmap) 
												userInfo:NULL 
												 repeats:YES];
	
} // end startAnimation

- (IBAction) stopAnimation:(id)pId {
	[nsTimerRef_1 invalidate];
	nsTimerRef_1	= nil;
	
	[nsTimerRef_2 invalidate];
	nsTimerRef_2	= nil;
} // end stopAnimation


- (IBAction)setParameter:(id)sender {
    
	if ( sender == parameterTextField ) {
        parametro = [parameterTextField floatValue];
     	[parameterTextField setFloatValue:parametro];   
    }	
	
	
}// set parameter

- (void) setInitOption_0:(id)sender {init_option = 0;}
- (void) setInitOption_1:(id)sender {init_option = 1;}
- (void) setInitOption_2:(id)sender {init_option = 2;}


- (void) initLatticeConfiguration:(id)sender {

	NSInteger x; NSInteger y;
	// perform percoltion on the lattice 
	for (y = 0; y < (int)Y_SIZE; y++)for (x = 0; x < (int)X_SIZE; x++) LatticeConfiguration[x][y] = 0;
	
	switch(init_option)
	{
		case 0:
			LatticeConfiguration[128][128] = 2;
			LatticeConfiguration[127][128] = 2;
			LatticeConfiguration[129][128] = 2;
			LatticeConfiguration[128][127] = 2;
			LatticeConfiguration[128][129] = 2;
		
			
			LatticeConfiguration[128 +64][128+64] = 3;
			LatticeConfiguration[127+64][128+64] = 3;
			LatticeConfiguration[129+64][128+64] = 3;
			LatticeConfiguration[128+64][127+64] = 3;
			LatticeConfiguration[128+64][129+64] = 3;
			
			LatticeConfiguration[128-64][128-64] = 1;
			LatticeConfiguration[127-64][128-64] = 1;
			LatticeConfiguration[129-64][128-64] = 1;
			LatticeConfiguration[128-64][127-64] = 1;
			LatticeConfiguration[128-64][129-64] = 1;
			
			
			break;
		case 1:
			for (x = 0; x < (int)X_SIZE; x++) LatticeConfiguration[x][128] = ceil((genrand()*3));
			break;
		case 2:
			for (y = 0; y < (int)Y_SIZE; y++)for (x = 0; x < (int)X_SIZE; x++) 
			{
				if(genrand() < (0.01)){LatticeConfiguration[x][y]=ceil((genrand()*3));}else {LatticeConfiguration[x][y]=0;};
			};
			break;
	}
	[self paintGradientBitmap];
};

- (void) updateLatticeConfiguration {
	float random_neighbor; 
	int random_x_coor, random_y_coor;
	//NSInteger x; NSInteger y,
	int sites;
	
	
//	for (y = 0; y < (int)Y_SIZE; y++)for (x = 0; x <(int)X_SIZE; x++) 
for (sites = 0; sites < (int)(Y_SIZE*X_SIZE); sites++)
	{
	//pick a random focal site
	random_x_coor = (int) floor(genrand()*X_SIZE); random_y_coor =(int) floor(genrand()*Y_SIZE);
	
	// pick random neighboor
		switch((int) ceil((genrand()*4)))
		{
			case 1: //south
				random_neighbor = LatticeConfiguration[random_x_coor][(int)((Y_SIZE + random_y_coor-1)%Y_SIZE)]; 
				break;
			case 2: //north
				random_neighbor = LatticeConfiguration[random_x_coor][(int)((Y_SIZE + random_y_coor+1)%Y_SIZE)];
				break;
			case 3: //east
				random_neighbor = LatticeConfiguration[(int)((X_SIZE + random_x_coor-1)%X_SIZE)][random_y_coor];
				break;
			case 4: //west
				random_neighbor = LatticeConfiguration[(int)((X_SIZE + random_x_coor+1)%X_SIZE)][random_y_coor];
				break;
		}; 
		
	switch( (int) LatticeConfiguration[random_x_coor][random_y_coor])
		{				
			case 0:
				// if its random neighbor is occupied: put a random_neighbor copy at the focal site which was 0
				if ( random_neighbor != 0)LatticeConfiguration[random_x_coor][random_y_coor] = random_neighbor;
				break;
			case 1:
				// if Rock's(1) random neighbor is occupied by Paper(2): put a 2 copy at the focal site which was 1
				if ( random_neighbor == 2)LatticeConfiguration[random_x_coor][random_y_coor] = 2;
				if (genrand() < parametro) LatticeConfiguration[random_x_coor][random_y_coor] = 0;
				break;	
			case 2:
				// if Paper's(2) random neighbor is occupied by Scissor(3): put a 3 copy at the focal site which was 2
				if ( random_neighbor == 3)LatticeConfiguration[random_x_coor][random_y_coor] = 3;
				if (genrand() < parametro ) LatticeConfiguration[random_x_coor][random_y_coor] = 0;
				break;		
			case 3:
				// if Scissor's(3) random neighbor is occupied by Rock(1): put a 1 copy at the focal site which was 3
				if ( random_neighbor == 1) LatticeConfiguration[random_x_coor][random_y_coor] = 1;
				if (genrand() < parametro) LatticeConfiguration[random_x_coor][random_y_coor] = 0;
				break;	
	};
	};
};

- (void) paintGradientBitmap {
	
	
	NSUInteger zIntRed	 = 255;
	NSUInteger zIntGreen = 255;
	NSUInteger zIntBlue  = 255;
	NSInteger x; 
	NSInteger y; 

	// prepare color mapping and render pixmap besed on the lattice above
//	NSUInteger zColourAry[3];
	for (y = 0; y < nsRectFrameRect.size.height; y++)  
		for (x = 0; x < nsRectFrameRect.size.width; x++) 
			{ 
			if(LatticeConfiguration[x][y] == 0)
				{	        zIntRed	 = 0;
							zIntGreen = 0;
							zIntBlue  = 0;
						
							NSUInteger zColourAry[3] = {zIntRed,zIntGreen,zIntBlue};
							[nsBitmapImageRepObj setPixel:zColourAry atX:x y:y];
				};
				
			if(LatticeConfiguration[x][y] == 1)
					{
				
						zIntRed	 =round(255);
						zIntGreen =  0;
						zIntBlue  = 0;
					
						NSUInteger zColourAry[3] = {zIntRed,zIntGreen,zIntBlue};
						[nsBitmapImageRepObj setPixel:zColourAry atX:x y:y];
					};
				
			if(LatticeConfiguration[x][y] == 2)
					{
					
					zIntRed	 = 0;
					zIntGreen = round(255);
					zIntBlue  = 0;
					NSUInteger zColourAry[3] = {zIntRed,zIntGreen,zIntBlue};
					[nsBitmapImageRepObj setPixel:zColourAry atX:x y:y];
					};	
			
	
				if(LatticeConfiguration[x][y] == 3)
				{
					
					zIntRed	 = 0;// round(255);
					zIntGreen = 0;//round(255);
					zIntBlue  = round(255);
					NSUInteger zColourAry[3] = {zIntRed,zIntGreen,zIntBlue};
					[nsBitmapImageRepObj setPixel:zColourAry atX:x y:y];
				};	
		}
	
	[self setNeedsDisplay:YES];

} // end paintGradientBitmap 



- (void)drawRect:(NSRect)pRect {

	[NSGraphicsContext saveGraphicsState];
	
	[nsBitmapImageRepObj drawInRect:pRect]; 
	
	[NSGraphicsContext restoreGraphicsState];
	
} // end drawRect


@end

